Index: mibs/d-link/DES-1210-28ME_B2
===================================================================
--- mibs/d-link/DES-1210-28ME_B2	(revision 11288)
+++ mibs/d-link/DES-1210-28ME_B2	(working copy)
@@ -1327,34 +2802,202 @@
         DESCRIPTION
             "Nothing / scan IP-MAC-Port Binding auto scan for the interface."
         ::= { securityIpMacPortBinding 7 }
-         
+
+    impbDhcpSnoopingTable     OBJECT-TYPE
+        SYNTAX SEQUENCE OF ImpbDhcpSnoopingEntry
+        MAX-ACCESS not-accessible
+        STATUS current
+        DESCRIPTION
+            "A table to display DHCP snooping entries of the device."
+        ::= { securityIpMacPortBinding 8 }
+
+    impbDhcpSnoopingEntry OBJECT-TYPE
+        SYNTAX ImpbDhcpSnoopingEntry
+        MAX-ACCESS not-accessible
+        STATUS current
+        DESCRIPTION
+            "An entry appears in DHCP snooping table for each interface
+ 	        in the system."
+        INDEX { impbDhcpSnoopingMacAddress, impbDhcpSnoopingIpAddress }
+        ::= { impbDhcpSnoopingTable 1 }
+
+    ImpbDhcpSnoopingEntry ::=
+           SEQUENCE {
+              impbDhcpSnoopingMacAddress
+                 MacAddress,
+              impbDhcpSnoopingIpAddress
+                 Ipv6Address,
+              impbDhcpSnoopingLeaseTime
+                 Integer32,
+              impbDhcpSnoopingPort
+                 Integer32,
+			  impbDhcpSnoopingremainingTime
+                 Integer32
+          }
+
+         impbDhcpSnoopingMacAddress OBJECT-TYPE
+           SYNTAX      MacAddress
+           MAX-ACCESS  read-only
+           STATUS      current
+           DESCRIPTION
+              "The MAC address associated of the DHCP snooping entry."
+           ::= { impbDhcpSnoopingEntry 1 }
+
+         impbDhcpSnoopingIpAddress OBJECT-TYPE
+           SYNTAX      Ipv6Address
+           MAX-ACCESS  read-only
+           STATUS      current
+           DESCRIPTION
+              "The IP address associated of the DHCP snooping entry."
+           DEFVAL { '00000000'H }
+           ::= { impbDhcpSnoopingEntry 2 }
+
+         impbDhcpSnoopingLeaseTime OBJECT-TYPE
+           SYNTAX      Integer32
+           MAX-ACCESS  read-only
+           STATUS      current
+           DESCRIPTION
+              "The lease time associated of the DHCP snooping entry."
+           ::= { impbDhcpSnoopingEntry 3 }
+
+         impbDhcpSnoopingPort OBJECT-TYPE
+           SYNTAX      Integer32
+           MAX-ACCESS  read-only
+           STATUS      current
+           DESCRIPTION
+              "The port number associated of the DHCP snooping entry."
+           ::= { impbDhcpSnoopingEntry 4 }
+
+		 impbDhcpSnoopingremainingTime OBJECT-TYPE
+           SYNTAX      Integer32
+           MAX-ACCESS  read-only
+           STATUS      current
+           DESCRIPTION
+              "The remaining time associated of the DHCP snooping entry."
+           ::= { impbDhcpSnoopingEntry 5 }
+
+    impbRoamingState OBJECT-TYPE
+           SYNTAX INTEGER  {
+                  disabled (0), enabled (1)
+            }
+           MAX-ACCESS  read-write
+           STATUS      current
+           DESCRIPTION
+              "Disable / enable IP-MAC-Port Binding roaming state."
+           ::= { securityIpMacPortBinding 9 }
+
+    impbVlanModeState OBJECT-TYPE
+           SYNTAX INTEGER  {
+                  disabled (0), enabled (1)
+            }
+           MAX-ACCESS  read-write
+           STATUS      current
+           DESCRIPTION
+              "Disable / enable IP-MAC-Port Binding vlan mode state."
+           ::= { securityIpMacPortBinding 10 }
+
+    impbVlanModeVlanList OBJECT-TYPE
+           SYNTAX      PortList
+           MAX-ACCESS  read-write
+           STATUS      current
+           DESCRIPTION
+              "IP-MAC-Port Binding vlan mode VID list."
+           ::= { securityIpMacPortBinding 11 }
+
+    impbDHCPv6PrefixDelegationSnoopState OBJECT-TYPE
+           SYNTAX INTEGER  {
+                  disabled (0), enabled (1)
+            }
+           MAX-ACCESS  read-write
+           STATUS      current
+           DESCRIPTION
+              "Configure DHCPv6 PD snooping state."
+           ::= { securityIpMacPortBinding 13 }
+
+    impbBindingtraplog OBJECT-TYPE
+           SYNTAX INTEGER  {
+                  disabled (2), enabled (1)
+            }
+           MAX-ACCESS  read-write
+           STATUS      current
+           DESCRIPTION
+              "This object is for enabling or disabling topology change event trap in the system."
+           ::= { securityIpMacPortBinding 14 }
+
+    impbBindingtrap  OBJECT IDENTIFIER ::= { securityIpMacPortBinding 15 }
+
+    impbBindingtrapsign  NOTIFICATION-TYPE
+           STATUS  obsolete
+           DESCRIPTION
+              "The object is for IMPB trap sign in the system."
+              ::= {impbBindingtrap 1 }
+
+    impbAutoScanCurrentStatus OBJECT-TYPE
+           SYNTAX INTEGER  {
+        		  stop (0), scanning (1)
+            }
+           MAX-ACCESS  read-only
+           STATUS      current
+           DESCRIPTION
+              "Show Auto scan status"
+           ::= { securityIpMacPortBinding 16 }
+
+	impbDhcpSnoopingTableClearPortList OBJECT-TYPE
+		SYNTAX      PortList
+		MAX-ACCESS  read-write
+		STATUS      current
+		DESCRIPTION
+            "This object allow the user to set the port list for impbDhcpSnoopingTableClear."
+		::= { securityIpMacPortBinding 17 }
+
+    impbDhcpSnoopingTableClearIPType OBJECT-TYPE
+           SYNTAX INTEGER  {
+                   ipv4 (0),  ipv6 (1),  both (2)
+            }
+           MAX-ACCESS  read-write
+           STATUS      current
+           DESCRIPTION
+              "This object allow the user to set the IP type for impbDhcpSnoopingTableClear."
+           ::= { securityIpMacPortBinding 18 }
+
+	impbDhcpSnoopingTableClear OBJECT-TYPE
+	   SYNTAX      TruthValue
+	   MAX-ACCESS  read-write
+	   STATUS      current
+	   DESCRIPTION
+		  "This object allows the user to clear the DHCP snooping entry.
+		  Setting  a value of 'true' causes the DHCP snooping entry to
+		  be cleared."
+		DEFVAL  { false }
+	   ::= { securityIpMacPortBinding 19 }
+
         -- ----------------------------------------------------------------
         -- The STP Bridge Global
         -- ----------------------------------------------------------------
         stpBridgeGlobal  OBJECT IDENTIFIER ::= { companySTP 1 }
-        
+
         stpModuleStatus OBJECT-TYPE
-           SYNTAX   INTEGER { 
-                        enabled(1), 
-                        disabled(2) 
+           SYNTAX   INTEGER {
+                        enabled(1),
+                        disabled(2)
                     }
            MAX-ACCESS  read-write
            STATUS      current
            DESCRIPTION
-              "The administrative status requested by management for the MST  
-              feature. The value enabled(1) indicates that Mst should be enabled  
-              in the device on all ports. The value disabled(2) indicates that 
-              Mst should be disabled in the device on all ports. The object can 
+              "The administrative status requested by management for the MST
+              feature. The value enabled(1) indicates that Mst should be enabled
+              in the device on all ports. The value disabled(2) indicates that
+              Mst should be disabled in the device on all ports. The object can
               be set to enabled(1) if and only if, fsMIMstSystemControl set to start."
            ::= { stpBridgeGlobal 1 }
-           
+
         stpProtocolVersion OBJECT-TYPE
            SYNTAX      INTEGER {
-                          stp(0),
+                          stp(1),
                           rstp(2),
                           mstp(3)
                        }
-           MAX-ACCESS  read-write 
+           MAX-ACCESS  read-write
            STATUS      current
            DESCRIPTION
               "The version of Spanning Tree Protocol the bridge is
@@ -1363,8 +3006,8 @@
         	   IEEE 802.1D and 'rstp(2)' indicates the Rapid Spanning
         	   Tree Protocol specified in IEEE 802.1w and 'mstp(3)'
         	   indicates the Multiple Spanning Tree Protocol Specified
-        	   in IEEE 802.1s." 
-           DEFVAL { mstp }
+        	   in IEEE 802.1s."
+           DEFVAL { rstp }
            ::= { stpBridgeGlobal 2 }
            
         stpBridgePriority OBJECT-TYPE
@@ -1495,6 +3138,83 @@
                path cost from this bridge to the CIST Root Bridge."
            ::= { stpBridgeGlobal 13 }      
            
+        stpTopologyChangeTrapStatus OBJECT-TYPE
+           SYNTAX      INTEGER  {
+        		 enabled(1),
+        		 disabled(2)
+            }  
+           MAX-ACCESS  read-write     
+           STATUS      current 
+           DESCRIPTION 
+              "This object is for enabling or disabling topology change event
+               trap in the system."
+           DEFVAL  { disabled }
+           ::= { stpBridgeGlobal 14 }  
+           
+        stpNewRootTrapStatus OBJECT-TYPE
+           SYNTAX      INTEGER  {
+        		 enabled(1),
+        		 disabled(2)
+            }  
+           MAX-ACCESS  read-write     
+           STATUS      current 
+           DESCRIPTION 
+              "This object is for enabling or disabling new root event
+               trap in the system."
+           DEFVAL  { disabled }
+           ::= { stpBridgeGlobal 15 }  		   
+
+        stpNewRootTraps  OBJECT IDENTIFIER ::= { stpBridgeGlobal 16 }
+         
+        stpBridgeMaxHop OBJECT-TYPE
+            SYNTAX      Timeout (600..4000)  
+            MAX-ACCESS  read-write
+            STATUS      current
+            DESCRIPTION
+               "The value that all bridges use for MaxAge when
+                this bridge is acting as the root. The granularity 
+                of this timer is specified to be 1 second.
+                An agent may return a badValue error if a set is
+                attempted to a value which is not a whole number
+                of seconds."
+            DEFVAL {2000}
+            ::= { stpBridgeGlobal 17 }         
+         
+        brgAddress NOTIFICATION-TYPE
+           STATUS  obsolete
+           DESCRIPTION
+              "The MAC address used by this bridge when it must
+               be referred to in a unique fashion."
+              ::= { stpNewRootTraps 1 }
+
+        oldDesignatedRoot NOTIFICATION-TYPE
+           STATUS  obsolete
+           DESCRIPTION
+              "The bridge identifier of the old root of the spanning
+ 	       tree instance as determined by the Spanning Tree Protocol
+ 	       as executed by this node."
+
+              ::= { stpNewRootTraps 2 }
+
+        mstiBridgeRegionalRoot NOTIFICATION-TYPE
+           STATUS  obsolete
+           DESCRIPTION
+              "MSTI Regional Root Identifier value for the Instance."
+              ::= { stpNewRootTraps 3 }
+
+        stpNniBpduAddr OBJECT-TYPE
+           SYNTAX   INTEGER { 
+                        dot1d (1), 
+                        dot1ad (2) 
+                    }
+           MAX-ACCESS  read-write
+           STATUS      current
+           DESCRIPTION
+              "The value dot1d(1) indicates that Tx BPDU Header should be   
+              01-80-c2-00-00-00 on nni ports when qinq enabled. The value dot1ad(2) indicates that 
+               Tx BPDU Header should be 01-80-c2-00-00-08 on nni ports when qinq enabled."
+           ::= { stpBridgeGlobal 18 }
+
      -- -------------------------------------
      -- The Spanning Tree Port Table   
      -- -------------------------------------
@@ -1532,7 +3252,7 @@
                   stpPortPathCost
                      INTEGER,
                   stpPortProtocolMigration
-                     TruthValue,
+                     INTEGER,
                   stpPortEdge
                      INTEGER,
                   stpPortAdminP2P
@@ -1610,7 +3330,10 @@
            ::= { stpPortEntry 5 }
            
         stpPortProtocolMigration OBJECT-TYPE
-           SYNTAX      TruthValue                
+           SYNTAX      INTEGER{
+                        false(0),
+                        true(1)
+                        }                
            MAX-ACCESS  read-write           
            STATUS      current
            DESCRIPTION
@@ -1865,7 +3588,9 @@
                mstInstanceVlanMapped3k 
                     OCTET STRING,
                mstInstanceVlanMapped4k 
-                    OCTET STRING
+                    OCTET STRING,
+               mstDeleteInstanceStatus
+                    TruthValue
            }
         
         mstInstanceIndex OBJECT-TYPE
@@ -1986,6 +3711,14 @@
                     support for VlanIndex values up to 4095."
             ::= { mstVlanMstiMappingEntry 7 }
             
+        mstDeleteInstanceStatus OBJECT-TYPE
+           SYNTAX      TruthValue
+              MAX-ACCESS  read-write
+              STATUS      current
+              DESCRIPTION
+                  "Delete Instance Index."
+              ::= { mstVlanMstiMappingEntry 8 }
+
         -- -----------------------------------------------------------------
         -- Mst Multiple Spanning Tree Instance Bridge Table
         -- -----------------------------------------------------------------
@@ -2021,6 +3754,26 @@
               be set to enabled(1) if and only if, fsMIMstSystemControl set to start."
            ::= { stpInstance 2 }
            
+        mstCiststpTopologyChangesCount OBJECT-TYPE
+             SYNTAX      Counter32
+              MAX-ACCESS  read-only
+           STATUS      current
+           DESCRIPTION
+              "The number of times that there have been atleast
+              one non-zero TcWhile Timer on this Bridge for Common
+              Spanning Tree context."
+           ::= { stpInstance 3 }
+
+        mstCiststpLastTopologyChange OBJECT-TYPE
+    SYNTAX      TimeTicks 
+   MAX-ACCESS  read-only
+   STATUS      current
+   DESCRIPTION
+         "The time (in hundredths of a second) since the
+         TcWhile Timer for any port in this Bridge was 
+         non-zero for this spanning tree instance."
+            DEFVAL {0}
+            ::= { stpInstance 4 }
         -- -----------------------------------------------------------------
         -- Mst Multiple Spanning Tree Instance Bridge Table : MSTI
         -- -----------------------------------------------------------------        
@@ -2032,7 +3785,7 @@
               "Table containing Bridge Information specific to Spanning 
                Tree Instance. This table maintains context ID as one 
                more index to support Multiple Instances."
-           ::= { stpInstance 3 } 
+           ::= { stpInstance 20 } 
          
         mstMstiBridgeEntry OBJECT-TYPE
            SYNTAX      MstMstiBridgeEntry       
@@ -2050,7 +3803,12 @@
               mstMstiBridgePriority 
                     Integer32,
               mstMstiStatus
-                    INTEGER
+                    INTEGER,
+              mstMstistpTopologyChangesCount
+                    Counter32,
+              mstMstistpLastTopologyChange
+                    TimeTicks
+                    
            }
         
         mstMstiInstanceIndex OBJECT-TYPE
@@ -2088,6 +3846,27 @@
               be set to enabled(1) if and only if, fsMIMstSystemControl set to start."
            ::= { mstMstiBridgeEntry 3 }
         
+        mstMstistpTopologyChangesCount OBJECT-TYPE
+             SYNTAX      Counter32
+              MAX-ACCESS  read-only
+           STATUS      current
+           DESCRIPTION
+              "The number of times that there have been atleast
+              one non-zero TcWhile Timer on this Bridge for Common
+              Spanning Tree context."
+           ::= { mstMstiBridgeEntry 4 }
+
+        mstMstistpLastTopologyChange OBJECT-TYPE
+    SYNTAX      TimeTicks 
+   MAX-ACCESS  read-only
+   STATUS      current
+   DESCRIPTION
+         "The time (in hundredths of a second) since the
+         TcWhile Timer for any port in this Bridge was 
+         non-zero for this spanning tree instance."
+            DEFVAL {0}
+            ::= { mstMstiBridgeEntry 5 }
+
         -- -----------------------------------------------------------------
         -- Mst Multiple Spanning Tree Instance Bridge Table
         -- -----------------------------------------------------------------
@@ -2135,7 +3914,7 @@
         
         mstCistPort OBJECT-TYPE
               SYNTAX      Integer32 (1..65535)
-              MAX-ACCESS  not-accessible
+              MAX-ACCESS  read-only
               STATUS      current
               DESCRIPTION
                   "The Port number of the port for which this entry contains   
@@ -2162,7 +3941,7 @@
         
         mstCistPortPathCost OBJECT-TYPE
               SYNTAX      Integer32 (1..200000000)
-              MAX-ACCESS  read-write           
+              MAX-ACCESS  read-only           
               STATUS      current
               DESCRIPTION
                   "The contribution of this port to the path cost of
@@ -2203,7 +3982,8 @@
                            backup(2),
                            root(3),
                            designated(4),
-                           master(5)
+                           master(5),
+                            root-inconsistent(6)
                           }
               MAX-ACCESS  read-only        
               STATUS      current
@@ -2254,7 +4034,7 @@
         
         mstMstiPort OBJECT-TYPE
               SYNTAX      Integer32 (1..65535)
-              MAX-ACCESS  not-accessible
+              MAX-ACCESS  read-only
               STATUS      current
               DESCRIPTION
                   "The Port number of the port for which this entry contains   
@@ -2281,7 +4061,7 @@
         
         mstMstiPortPathCost OBJECT-TYPE
               SYNTAX      Integer32 (1..200000000)
-              MAX-ACCESS  read-write           
+              MAX-ACCESS  read-only            
               STATUS      current
               DESCRIPTION
                   "The contribution of this port to the path cost of
@@ -2322,7 +4102,8 @@
                            backup(2),
                            root(3),
                            designated(4),
-                           master(5)
+                           master(5),
+                            root-inconsistent(6)
                           }
               MAX-ACCESS  read-only        
               STATUS      current
@@ -2350,7 +4131,7 @@
             STATUS current
             DESCRIPTION
                 "A Static MAC entry containing the mac and forwarding port."
-            INDEX { staticMcastVlanID, staticMcastMac, staticMcastEgressPorts}
+            INDEX { staticMcastVlanID, staticMcastMac, staticMcastEgressPorts, staticMcastIpAddr}
             ::= { staticMcastTable 1 }
 
         StaticMcastEntry ::= SEQUENCE {
@@ -2357,11 +4138,12 @@
             staticMcastVlanID     	 INTEGER,
             staticMcastMac           MacAddress,
             staticMcastEgressPorts   PortList,
+            staticMcastIpAddr        IpAddress,
             staticMcastStatus        RowStatus
         }
 
         staticMcastVlanID OBJECT-TYPE
-            SYNTAX INTEGER
+            SYNTAX INTEGER (1..4094)
             MAX-ACCESS read-only
             STATUS current
             DESCRIPTION
@@ -2377,7 +4159,7 @@
            ::= { staticMcastEntry 2 }
 
         staticMcastEgressPorts OBJECT-TYPE
-            SYNTAX      PortList
+            SYNTAX      PortList (SIZE(1..28))
             MAX-ACCESS  read-only
             STATUS      current
             DESCRIPTION
@@ -2393,6 +4175,14 @@
                 "IEEE 802.1Q/D11 Section 12.7.7.3, 11.2.3.2.3"
             ::= { staticMcastEntry 3 }
         
+        staticMcastIpAddr  OBJECT-TYPE
+           SYNTAX      IpAddress
+           MAX-ACCESS  read-only
+           STATUS      current
+           DESCRIPTION 
+              "Static Multicast IP Address."
+           ::= { staticMcastEntry 4 }
+
         staticMcastStatus OBJECT-TYPE
             SYNTAX     RowStatus
             MAX-ACCESS read-write
@@ -2401,33 +4191,33 @@
                 "The status of an entry in the Static Mcast Table.  Only a subset
                  of the rowstatus variables (active, createAndGo, destroy) 
                  are available."
-            ::= { staticMcastEntry 4 }
+            ::= { staticMcastEntry 5 }
 
 
   		-- ----------------------------------------------------------
 		-- The 802.1Q VLAN Groups
 		-- ----------------------------------------------------------      		
+-- ----------------------------------------------------------
+--        dot1qVlanManagementOnOff OBJECT-TYPE
+--            SYNTAX INTEGER {
+--                   enabled(1),
+--                   disabled(2)
+--            }
+--            MAX-ACCESS read-write
+--            STATUS current
+--            DESCRIPTION
+--                "Enable/Disable management VLAN mechanism."
+--            ::= { companyDot1qVlanGroup 2 }
 
-        dot1qVlanManagementOnOff OBJECT-TYPE
-            SYNTAX INTEGER {
-                   enabled(1),
-                   disabled(2)
-            }
-            MAX-ACCESS read-write
-            STATUS current
-            DESCRIPTION
-                "Enable/Disable management VLAN mechanism."
-            ::= { companyDot1qVlanGroup 2 }
-
-        dot1qVlanManagementid OBJECT-TYPE
-            SYNTAX INTEGER
-            MAX-ACCESS read-write
-            STATUS current
-            DESCRIPTION
-                "The management VLAN ID, which will allow to forward packets of that VLAN to CPU."
-            DEFVAL { 1 }
-            ::= { companyDot1qVlanGroup 3 }
-
+--        dot1qVlanManagementid OBJECT-TYPE
+--            SYNTAX INTEGER
+--            MAX-ACCESS read-write
+--            STATUS current
+--            DESCRIPTION
+--                "The management VLAN ID, which will allow to forward packets of that VLAN to CPU."
+--            DEFVAL { 1 }
+--            ::= { companyDot1qVlanGroup 3 }
+-- ----------------------------------------------------------   
         dot1qVlanAsyOnOff OBJECT-TYPE
             SYNTAX INTEGER {
                    enabled(1),
@@ -2461,19 +4251,21 @@
             DESCRIPTION
                 "Information for a VLAN configured into the
                 device by (local or network) management."
-            INDEX   { dot1qVlanName }
+            INDEX   { dot1qVlanId }
             ::= { dot1qVlanTable 1 }
         
         Dot1qVlanEntry ::=
             SEQUENCE {
+                dot1qVlanId
+                    Integer32,
                 dot1qVlanName
                     SnmpAdminString,
                 dot1qVlanEgressPorts
-                    PortList,
+                    PortList,                  
                 dot1qVlanForbiddenPorts
-                    PortList,
+                    PortList,                                       
                 dot1qVlanUntaggedPorts
-                    PortList,
+                    PortList, 
                 dot1qVlanAdvertisementStatus
                     INTEGER,
                 dot1qVlanRowStatus
@@ -2480,6 +4272,15 @@
                     RowStatus
             }
         
+        dot1qVlanId OBJECT-TYPE
+            SYNTAX      Integer32 (1..4094)
+            MAX-ACCESS  read-only
+            STATUS      current
+            DESCRIPTION
+                "An administratively assigned Id, which is used
+                to identify the VLAN."
+            ::= { dot1qVlanEntry 1 }
+
         dot1qVlanName OBJECT-TYPE
             SYNTAX      SnmpAdminString (SIZE (0..20))
             MAX-ACCESS  read-create
@@ -2489,7 +4290,7 @@
                 to identify the VLAN."
             REFERENCE
                 "IEEE 802.1Q/D11 Section 12.10.2.1"
-            ::= { dot1qVlanEntry 1 }
+            ::= { dot1qVlanEntry 2 }
         
         dot1qVlanEgressPorts OBJECT-TYPE
             SYNTAX      PortList
@@ -2507,11 +4308,11 @@
                 appropriate length, indicating not fixed."
             REFERENCE
                 "IEEE 802.1Q/D11 Section 12.7.7.3, 11.2.3.2.3"
-            ::= { dot1qVlanEntry 2 }
-        
+            ::= { dot1qVlanEntry 3 } 
+                    
         dot1qVlanForbiddenPorts OBJECT-TYPE
             SYNTAX      PortList
-            MAX-ACCESS  read-only
+            MAX-ACCESS  read-write
             STATUS      current
             DESCRIPTION
                 "The set of ports which are prohibited by management
@@ -2526,7 +4327,7 @@
                 excluding all ports from the forbidden set."
             REFERENCE
                 "IEEE 802.1Q/D11 Section 12.7.7.3, 11.2.3.2.3"
-            ::= { dot1qVlanEntry 3 }
+            ::= { dot1qVlanEntry 4 }      
         
         dot1qVlanUntaggedPorts OBJECT-TYPE
             SYNTAX      PortList
@@ -2545,8 +4346,8 @@
                 option."
             REFERENCE
                 "IEEE 802.1Q/D11 Section 12.10.2.1"
-            ::= { dot1qVlanEntry 4 }
-        
+            ::= { dot1qVlanEntry 5 }
+ 
         dot1qVlanAdvertisementStatus OBJECT-TYPE
             SYNTAX      INTEGER {
                    enabled(1),
@@ -2556,8 +4357,8 @@
             STATUS      current
             DESCRIPTION
                 "Enable/Disable Advertisement Status of the IEEE 802.1Q VLAN."
-            ::= { dot1qVlanEntry 5 }
-
+            ::= { dot1qVlanEntry 6 }
+ 
         dot1qVlanRowStatus OBJECT-TYPE
             SYNTAX      RowStatus
             MAX-ACCESS  read-create
@@ -2567,8 +4368,61 @@
                 entries can be created in dot1qVlanTable and existing entries can be
                 removed from dot1qVlanTable. It can be used as specified in the SNMP
                 v2 standard."
-            ::= { dot1qVlanEntry 6 }
+            ::= { dot1qVlanEntry 7 }   
 
+        -- -------------------------------------------------------------
+        -- The VLAN Port Configuration Table
+        -- -------------------------------------------------------------
+        
+        dot1qVlanPortTable OBJECT-TYPE
+            SYNTAX      SEQUENCE OF Dot1qVlanPortEntry
+            MAX-ACCESS  not-accessible
+            STATUS      current
+            DESCRIPTION
+                "A table containing per port control and status
+                information for VLAN configuration in the device."
+            ::= { companyDot1qVlanGroup  7 }
+        
+        dot1qVlanPortEntry OBJECT-TYPE
+            SYNTAX      Dot1qVlanPortEntry
+            MAX-ACCESS  not-accessible
+            STATUS      current
+            DESCRIPTION
+                "Information controlling VLAN configuration for a port
+                on the device."
+            AUGMENTS { dot1dBasePortEntry }
+            ::= { dot1qVlanPortTable 1 }
+        
+        Dot1qVlanPortEntry ::=
+            SEQUENCE {
+                dot1qVlanPvid
+                    VlanIndex
+            }
+        
+        dot1qVlanPvid OBJECT-TYPE
+            SYNTAX      VlanIndex
+            MAX-ACCESS  read-write
+            STATUS      current
+            DESCRIPTION
+                "The PVID, the VLAN ID assigned to untagged frames or
+                Priority-Tagged frames received on this port."
+            REFERENCE
+                "IEEE 802.1Q/D11 Section 12.10.1.1"
+            DEFVAL      { 1 }
+            ::= { dot1qVlanPortEntry 1 }    
+
+      dot1qVlanPVIDAutoAssignOnOff OBJECT-TYPE
+            SYNTAX INTEGER {
+                   enabled(1),
+                   disabled(2)
+            }
+            MAX-ACCESS read-write
+            STATUS current
+            DESCRIPTION
+                "Enable/Disable VLAN PVID auto assignment"
+            ::= { companyDot1qVlanGroup  9 }
+            
+
   		-- ----------------------------------------------------------
 		-- The GVRP Groups
 		-- ----------------------------------------------------------
@@ -2697,9 +4551,13 @@
         -- ----------------------------------------------------------
 		-- The DHCP/BOOTP Relay
 		-- ----------------------------------------------------------
-
+  dhcpBOOTPRelayControl                   OBJECT IDENTIFIER ::= { companyDHCPRelay 1 }
+  dhcpBOOTPRelayManagement                OBJECT IDENTIFIER ::= { companyDHCPRelay 2 }
+  dhcpBOOTPRelayManagementOption82        OBJECT IDENTIFIER ::= { dhcpBOOTPRelayManagement 2 }
+        
 		-- The DHCP/BOOTP Relay Control
-
+        
+            
             dhcpBOOTPRelayState OBJECT-TYPE
                 SYNTAX  INTEGER {
                     enabled(1),
@@ -2728,7 +4586,58 @@
                     If this time is exceeded, the switch will drop the DHCP packet."
             ::= { dhcpBOOTPRelayControl 3 }
 
+            dhcpBOOTPRelayEnablePortlist OBJECT-TYPE 
+               SYNTAX      PortList
+               MAX-ACCESS  read-write 
+               STATUS      current 
+               DESCRIPTION 
+                   "This object indicates DHCP relay function is enabled or disabled by portlist."
+               ::= { dhcpBOOTPRelayControl 4 }
 
+            dhcpRelayVlanTable OBJECT-TYPE
+                SYNTAX  SEQUENCE OF DHCPRelayVlanSettings
+                MAX-ACCESS  not-accessible
+                STATUS  current
+                DESCRIPTION
+                    "This table indicates the IP address as a destination to forward (relay) DHCP packets to."
+            ::= { dhcpBOOTPRelayControl 5 }
+
+            dhcpRelayVlanTableEntry OBJECT-TYPE
+                SYNTAX  DHCPRelayVlanSettings
+                MAX-ACCESS  not-accessible
+                STATUS  current
+                DESCRIPTION
+                    "A list of information indicates the IP address as a destination to forward (relay) DHCP packets to."
+                INDEX  { dhcpRelayVlanSettingsVLANID }
+            ::= { dhcpRelayVlanTable 1 }
+
+            DHCPRelayVlanSettings ::=
+                SEQUENCE {
+                    dhcpRelayVlanSettingsVLANID
+                        INTEGER,
+                    dhcpRelayVlanSettingsState
+                        INTEGER
+                }
+
+	        dhcpRelayVlanSettingsVLANID OBJECT-TYPE
+                SYNTAX  INTEGER (1..4094)
+                MAX-ACCESS  read-only
+                STATUS  current
+                DESCRIPTION
+                    "This object displays the current VLAN ID of the device."
+            ::= { dhcpRelayVlanTableEntry 1 }
+
+            dhcpRelayVlanSettingsState OBJECT-TYPE
+                SYNTAX  INTEGER {
+                    enabled(1),
+                    disabled(2)
+                }
+                MAX-ACCESS  read-write
+                STATUS  current
+                DESCRIPTION
+                    "This object indicates DHCP relay function of VLAN is enabled or disabled."
+            ::= { dhcpRelayVlanTableEntry 2 }
+
 		-- The DHCP/BOOTP Relay Management
 		-- The DHCP/BOOTP Relay Interface Settings Table
 
@@ -2823,7 +4732,8 @@
 	        dhcpBOOTPRelayOption82RemoteIDType OBJECT-TYPE
                 SYNTAX  INTEGER {
                     default(1),
-                    userdefined(2)
+                    userdefined(2),
+                    userdefinedhex(3)
                 }
                 MAX-ACCESS  read-write
                 STATUS  current
